parser grammar VariableParserParser;
options { tokenVocab=VariableParserLexer; }

varlist: var (VAR_SEPARATOR var)*; //Build list of variables
var:    ID vartype;
vartype: ':' type_info
       | defaulttype;

defaulttype: ;

type_info: simple_type_info
         | '{' subtype '}';

subtype: subtype_var '|' pvs_expr;
subtype_var:    ID subtype_vartype;
subtype_vartype: ':' simple_type_info
       | defaulttype;
pvs_expr: PVS_EXPR;

simple_type_info: bool_type
         | real_type
         | fixed_type
         | unknown_type;

bool_type: BOOL_TYPE;

real_type: 'real';

fixed_type: 'fixedt' '(' NAT NAT_SEPARATOR NAT ')'
          | 'fixedt' '(' NAT NAT_SEPARATOR NAT NAT_SEPARATOR NAT ')';

unknown_type: UNKNOWN_TYPE;
